cat >/kill-partman.sh <<-EOF
while [ ! -f /var/lib/dpkg/info/partman-base.postinst ]; do 
    sleep 1
done
cat /tmp/dis_pm > /var/lib/dpkg/info/partman-base.postinst
EOF

cat >/tmp/dis_pm <<-EOF
#!/bin/sh

main () {
    # install required installer modules and activate crypt kernel module
    anna-install parted-udeb cryptsetup-udeb partman-crypto-dm lvm2-udeb dosfstools-udeb 
    depmod -a 

{% if storage.partInitial %} 
    # create partition table and partitions (partInitial is enabled !)
    parted --script {{ storage.installDisks[0].name }} mklabel gpt \
    mkpart "bios_grub" "" 1MiB 2MiB \
    set 1 bios_grub on \
    mkpart "boot" "" 2MiB 2050MiB \
    mkpart "esp" "" 2050MiB 4098MiB \
    set 3 boot on \
    mkpart "os" "" 4098MiB 24578MiB \
    mkpart "data" "" 24578MiB 45058MiB \

    udevadm settle && sleep 5 && udevadm settle && sleep 5
{%- endif %}

    # format LUKS devices
    echo '{{ auth.initialPw }}'|cryptsetup luksFormat {{ storage.installDisks[0].name }}-part4 --force-password -c aes-xts-plain64 -s 512 -h sha512 -i 5000 --use-random --align-payload=2048
{% if storage.partInitial %} 
    echo '{{ auth.initialPw }}'|cryptsetup luksFormat {{ storage.installDisks[0].name }}-part5 --force-password -c aes-xts-plain64 -s 512 -h sha512 -i 5000 --use-random --align-payload=2048
{%- endif %}

    udevadm settle && sleep 5 && udevadm settle && sleep 5

    # open LUKS devices
    echo '{{ auth.initialPw }}'|cryptsetup luksOpen --allow-discards {{ storage.installDisks[0].name }}-part4 crypt_root
    echo '{{ auth.initialPw }}'|cryptsetup luksOpen --allow-discards {{ storage.installDisks[0].name }}-part5 crypt_data

    udevadm settle && sleep 5 && udevadm settle && sleep 5


    # create filesystems
    mkfs.ext4 {{ storage.installDisks[0].name }}-part2
    mkfs.fat -F 32 {{ storage.installDisks[0].name }}-part3
    mkfs.ext4 /dev/mapper/crypt_root
{% if storage.partInitial %} 
    mkfs.ext4 /dev/mapper/crypt_data
{%- endif %}

    udevadm settle && sleep 5 && udevadm settle && sleep 5


    # create target filesystem directory structure and mount filesystems
    mkdir -p /target
    modprobe ext4
    modprobe vfat
    mount -t ext4 -o rw,relatime,discard,errors=remount-ro /dev/mapper/crypt_root /target
    mkdir -p /target/boot
    mount -t ext4 -o rw,relatime,discard {{ storage.installDisks[0].name }}-part2 /target/boot
    mkdir -p /target/boot/efi
    mount -t vfat -o rw,discard,umask=0077 {{ storage.installDisks[0].name }}-part3 /target/boot/efi
    mkdir -p /target/srv/volumes/data
    mount -t ext4 -o rw,relatime,discard /dev/mapper/crypt_data /target/srv/volumes/data
    mount

    # create crypttab and fstab in target filesystem
    mkdir -p /target/etc

    echo "crypt_root {{ storage.installDisks[0].name }}-part4 none luks,discard" > /target/etc/crypttab
    echo "crypt_data {{ storage.installDisks[0].name }}-part5 none luks,discard" >> /target/etc/crypttab

    echo "/dev/mapper/crypt_root / ext4 rw,relatime,discard,errors=remount-ro 0 1" > /target/etc/fstab
    echo "{{ storage.installDisks[0].name }}-part2 /boot ext4 rw,relatime,discard 0 2" >> /target/etc/fstab
    echo "{{ storage.installDisks[0].name }}-part3 /boot/efi vfat rw,discard,umask=0077 0 3" >> /target/etc/fstab
    echo "/dev/mapper/crypt_data /srv/volumes/data ext4 rw,relatime,discard 0 2" >> /target/etc/fstab
}

main >/tmp/kill-partman-stage2.log 2>&1
EOF

sh /kill-partman.sh >/tmp/kill-partman.log 2>&1 &
